/*
	rls_modulesvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	Sun Dec 17 20:48:06 EST 2000	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "rlsn.hh" 	// rlsFormat

// NML Channel Pointers
static RCS_CMD_CHANNEL *rls_cmd = NULL;
static RCS_STAT_CHANNEL *rls_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// rls
	rls_cmd = new RCS_CMD_CHANNEL(rlsFormat, "rls_cmd", "rls_modulesvr", "rls_module.nml");
	if(NULL == rls_cmd)
		return -1;
	if(!rls_cmd->valid())
		return -1;

	rls_stat = new RCS_STAT_CHANNEL(rlsFormat, "rls_sts", "rls_modulesvr", "rls_module.nml");
	if(NULL == rls_stat)
		return -1;
	if(!rls_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "rls_modulesvr", "rls_module.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// rls
	if(NULL != rls_cmd)
	{
		delete rls_cmd;
		rls_cmd = NULL;
	}

	if(NULL != rls_stat)
	{
		delete rls_stat;
		rls_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int rls_modulesvr_run();

int rls_modulesvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

